#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <malloc.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <dmedia/audio.h>
#include <errno.h>
#include "encode.h"

static void Abandon(char *s);
static void get_file_info(file_info *fInfo);
static void get_url_info(file_info *fInfo);

void main(void)
{
  file_info fInfo;
  FILE *infp, *outfp;

  get_file_info(&fInfo);
  
  infp = fopen(fInfo.inputfile, "r");
  outfp = fopen(fInfo.outputfile, "a");

  prepend(outfp, &fInfo);

  encode(outfp,infp, &fInfo);

}

static void get_file_info(file_info *fInfo)
{
  int n, ch, i;

  fprintf(stdout, "Enter the input aiff filename: ");
  fscanf(stdin, "%s", fInfo->inputfile);
 
  n = strlen(fInfo->inputfile);
  strcpy(fInfo->outputfile, fInfo->inputfile);
  printf("output file = %s\n",fInfo->outputfile); 
  strcpy((fInfo->outputfile)+ (n-4), "adpcm");
  strcat(fInfo->outputfile, "\0");

  fprintf(stdout, "output file = %s\n", fInfo->outputfile);

  fprintf(stdout, "URLs?(1- yes/0- no):");
  fscanf(stdin, "%d", &ch);

  if (ch)
    fInfo->urlFlag = 1;
  else 
    fInfo->urlFlag = 0;

  if (fInfo->urlFlag)
    get_url_info(fInfo);

}

static void get_url_info(file_info *fInfo)
{
  int i;

  fprintf(stdout, "how many:");
  fscanf(stdin, "%d",&fInfo->numUrls);
  
  fInfo->url = (char **)malloc(sizeof(char *) *
				     fInfo->numUrls);
  if (!fInfo->url)
    Abandon("Memory allocation failure in get_file_info");
  
  for (i = 0; i < fInfo->numUrls; i++) {
    fInfo->url[i] = (char *) malloc(sizeof(char) * 256);
    if (!fInfo->url[i])
      Abandon("Memory allocation failure in get_file_info");
  }
  
  fInfo->time = (long *)malloc(sizeof(long) *fInfo->numUrls);
  if (!fInfo->url)
    Abandon("Memory allocation failure in get_file_info");
  
  for (i = 0; i < fInfo->numUrls; i++) {
    fprintf(stdout, "Enter Url and time of occurence: ");
    fscanf(stdin, "%s %ld", fInfo->url[i], &fInfo->time[i]);
    fprintf(stdout, "\n%s %ld\n", fInfo->url[i], fInfo->time[i]);
  }
    

}

static void Abandon(char *s)
{
  fprintf(stderr, "fatal error: %s\n", s);
  exit(1);
}
  
